var MAX_VOLUME = 3.5;
var SECONDS_FOR_RESTART = 4;

var drinks = [
                {"element" : "Water", "name" : "Voda", "volume" : 0.5, "level" : 0, "drunk" : 0},
                {"element" : "Cola", "name" : "Cola", "volume" : 0.5, "level" : 1, "drunk" : 0},
                {"element" : "Beer", "name" : "Pivo", "volume" : 0.5, "level" : 2, "drunk" : 0},
                {"element" : "Juice", "name" : "Džus", "volume" : 0.5, "level" : 0, "drunk" : 0},
                {"element" : "Energy", "name" : "En.<br>nápoj", "volume" : 0.5, "level" : 1, "drunk" : 0},
                {"element" : "Tea", "name" : "Čaj", "volume" : 0.5, "level" : 0, "drunk" : 0}
            ];


var statesIgor = [
                    {"img" : "Unhappy2", "circle" : "Nok", "audio" : "Unhappy2"},
                    {"img" : "Unhappy1", "circle" : "Nok", "audio" : ""},
                    {"img" : "Normal", "circle" : "Ok", "audio" : ""},
                    {"img" : "Happy1", "circle" : "Ok", "audio" : ""},
                    {"img" : "Happy2", "circle" : "Ok", "audio" : ""}
            ];


var initAnimOrder = [
                        {"order" : 1, "element" : "divPlayNadpis", "class" : "animPlay", "audio" : "Jingle"},
                        {"order" : 2, "element" : "ImgNadpisDejte", "class" : "animNadpisDejte", "audio" : ""},
                        {"order" : 3, "element" : "ImgNadpisIgorovi", "class" : "animNadpisIgorovi", "audio" : ""},
                        {"order" : 4, "element" : "ImgNadpisNapit", "class" : "animNadpisNapit", "audio" : ""},
                        {"order" : 5, "element" : "divPopis", "class" : "animPopis", "audio" : ""},                        
                        {"order" : 6, "element" : "imgIgorNormal", "class" : "animIgorNormalInit", "audio" : ""},
                        {"order" : 6, "element" : "imgIgorHappy1", "class" : "animIgorHappy1Init", "audio" : ""},
                        {"order" : 7, "element" : "divMeter", "class" : "animFadeIn", "audio" : ""},
                        {"order" : 7, "element" : "imgStatusCircleNone", "class" : "animFadeIn", "audio" : ""},
                        {"order" : 7, "element" : "divInfo", "class" : "animFadeIn", "audio" : ""},
                        {"order" : 7, "element" : "divImgDrinkWater", "class" : "animWater",                    "audio" : "DrinkAppear"},
                        {"order" : 7, "element" : "divImgDrinkWaterLabelTable", "class" : "animWaterTable",     "audio" : "TableAppear"},
                        {"order" : 8, "element" : "divImgDrinkWater", "class" : "animWater1",                   "audio" : ""},
                        {"order" : 8, "element" : "divImgDrinkWaterLabelTable", "class" : "animWaterTable1",    "audio" : ""},
                        {"order" : 8, "element" : "divImgDrinkCola", "class" : "animCola",                      "audio" : "DrinkAppear"},
                        {"order" : 8, "element" : "divImgDrinkColaLabelTable", "class" : "animColaTable",       "audio" : "TableAppear"},
                        {"order" : 9, "element" : "divImgDrinkCola", "class" : "animCola1",                     "audio" : ""},
                        {"order" : 9, "element" : "divImgDrinkColaLabelTable", "class" : "animColaTable1",      "audio" : ""},
                        {"order" : 9, "element" : "divImgDrinkBeer", "class" : "animBeer",                      "audio" : "DrinkAppear"},
                        {"order" : 9, "element" : "divImgDrinkBeerLabelTable", "class" : "animBeerTable",       "audio" : "TableAppear"},
                        {"order" : 10, "element" : "divImgDrinkBeer", "class" : "animBeer1",                     "audio" : ""},
                        {"order" : 10, "element" : "divImgDrinkBeerLabelTable", "class" : "animBeerTable1",      "audio" : ""},
                        {"order" : 10, "element" : "divImgDrinkJuice", "class" : "animJuice",                    "audio" : "DrinkAppear"},
                        {"order" : 10, "element" : "divImgDrinkJuiceLabelTable", "class" : "animJuiceTable",     "audio" : "TableAppear"},
                        {"order" : 11, "element" : "divImgDrinkJuice", "class" : "animJuice1",                  "audio" : ""},
                        {"order" : 11, "element" : "divImgDrinkJuiceLabelTable", "class" : "animJuiceTable1",   "audio" : ""},
                        {"order" : 11, "element" : "divImgDrinkEnergy", "class" : "animEnergy",                 "audio" : "DrinkAppear"},
                        {"order" : 11, "element" : "divImgDrinkEnergyLabelTable", "class" : "animEnergyTable",  "audio" : "TableAppear"},
                        {"order" : 12, "element" : "divImgDrinkEnergy", "class" : "animEnergy1",                "audio" : ""},
                        {"order" : 12, "element" : "divImgDrinkEnergyLabelTable", "class" : "animEnergyTable1", "audio" : ""},
                        {"order" : 12, "element" : "divImgDrinkTea", "class" : "animTea",                       "audio" : "DrinkAppear"},
                        {"order" : 12, "element" : "divImgDrinkTeaLabelTable", "class" : "animTeaTable",        "audio" : "TableAppear"},
                        {"order" : 13, "element" : "divImgDrinkTea", "class" : "animTea1",                      "audio" : ""},
                        {"order" : 13, "element" : "divImgDrinkTeaLabelTable", "class" : "animTeaTable1",       "audio" : ""}

                    ];

/*
var initAnimOrder = [
                        {"order" : 1, "element" : "divPlayNadpis", "class" : "animPlay", "audio" : "Jingle"},
                        {"order" : 2, "element" : "ImgNadpisDejte", "class" : "animNadpisDejte", "audio" : ""},
                        {"order" : 3, "element" : "ImgNadpisIgorovi", "class" : "animNadpisIgorovi", "audio" : ""},
                        {"order" : 4, "element" : "ImgNadpisNapit", "class" : "animNadpisNapit", "audio" : ""},
                        {"order" : 5, "element" : "divPopis", "class" : "animPopis", "audio" : ""},
                        
                    ];
*/
var animationState;

var statuses = [{"id" : 0, "descr" : "None"}, 
                {"id" : 1, "descr" : "Ok"}, 
                {"id" : 2, "descr" : "Nok"}
                ];

var totalVolume;

var levels = new Array(3);

var lastLevel;

var stateIgor;

var continueGame;

var onIgor = false;

var dragData = "";

function runGame() {
    
    enableDragDrinks(false);
    
    initialAnimations();
    
    initDrunk();
    initValues();
    
    enableDragDrinks(true);
}


function startGame() {

    enableDragDrinks(false);

    initDrunk();
    initValues();
    
    showIgorImage();
    
    enableDragDrinks(true);

}


function exitGame() {
    
    document.getElementById("audioMouseClicked").play();

    //window.close();
    
}

function resetGame() {
    
    document.getElementById("audioMouseClicked").play();

    
    enableDragDrinks(false);
    
    setTimeout(startGame, SECONDS_FOR_RESTART * 1000);
    
}

function enableDragDrinks(allow) {
    var i;
    var el;
    
    for (i = 0; i < drinks.length; i++) {
        
        el = document.getElementById("ImgDrink" + drinks[i].element);
        
        el.draggable = allow;
        
        
    }
}

function drag(e) {
    var moveDrink = document.getElementById("div" + e.target.id + "Picture").cloneNode(true);
    document.getElementById("divImgDrinkMove").appendChild(moveDrink);
    
    e.dataTransfer.setData("text", e.target.id);
    
    dragData = e.target.id;
    
    e.dataTransfer.setDragImage(document.getElementById("divEmpty"), 0, 0);

    document.getElementById("divImgDrinkMove").appendChild(moveDrink);
    
}


function isMouseOverIgor(e) {
    var is = false;
    
    var divImgIgor = document.getElementById("divImgIgor");
    var imgX = divImgIgor.offsetLeft;
    var imgY = divImgIgor.offsetTop;
    var imgW = divImgIgor.offsetWidth;
    var imgH = divImgIgor.offsetHeight;
    
    var mouseX = e.pageX;
    var mouseY = e.pageY;
    
    
    if (
            (mouseX >= imgX) && (mouseX <= imgX + imgW) &&
            (mouseY >= imgY) && (mouseY <= imgY + imgH)
        ) {
    
        is = true;
    }    
     
    return is; 
}

function dragEnded(e) {
    var dm = document.getElementById("divImgDrinkMove");
    dm.removeChild(dm.childNodes[0]); 
    dm.style.left="-100%";
    
    if (isMouseOverIgor(e)) {
    
        drop(e);
    }    
    
}

function allowDrop(e) {
    
    e.preventDefault();
}

function drop(e) {
    
    addDrink(dragData.replace('ImgDrink', ''));
}

function mouseDraggedOver(e) {
    
    var dm = document.getElementById("divImgDrinkMove");
    
    dm.childNodes[0].style.cursor = "move";
    
    
    
    var drink = document.getElementById("divImgDrinkMove");
    var dw = drink.offsetWidth;
    var dh = drink.offsetHeight;
    
    drink.style.left = (e.pageX - (dw / 4)) + 'px';
    drink.style.top = (e.pageY - (dh / 2)) + 'px';
    
}

function mouseOverDrink(e) {
    btnMouseEntered();

    document.getElementById(e.target.id).style.transform = "scale(1.5)";
}

function mouseOutDrink(e) {
    document.getElementById(e.target.id).style.transform = "scale(1.0)";
}

function printDrunkInfo () {
    var i;
    //drunk
    console.log('Napoje:');
    for (i = 0; i < levels.length; i++) {
        console.log('Level ' + i + ': ' + levels[i]);
    }
    console.log('Posledni level: ' + lastLevel);
    console.log('Celkove mnozstvi: ' + totalVolume);
    console.log('stav Igora: ' + stateIgor);
    console.log('---------');
    
}


//Aktualizace obrázku Igora a přehrání zvuku
function showIgorImage() {
    var i;
    var el;
    var aud;
    
    for (i = 0; i < statesIgor.length; i++) {
        el = document.getElementById("imgIgor" + statesIgor[i].img);
        
        
        if (stateIgor === i) {
            
            el.style.zIndex = 20;
            el.style.visibility = "visible";

            if ((!continueGame) && (statesIgor[i].audio !== '')) {
                aud = document.getElementById("audioIgor" + statesIgor[i].audio);
                if (aud !== null) {
                    aud.play();
                }
            }    

            if (!continueGame) {
                showStatus(statesIgor[i].circle);
            } else {
                showStatus("None");
            }
            
        } else {
            el.style.zIndex = 10;
            el.style.visibility = "hidden";

        
        }
    }
    
}


//Zobrazení stavu Igora
function updateIgorState() {
    
    showIgorImage(statesIgor[stateIgor]);    
    
    if (!continueGame) {
        resetGame();
    }
    
}


//Výpočet stavu Igora
function countIgorState() {
    
   
    if (levels[2] > 0) {
        //Pivo
        stateIgor = 1;
        if (levels[2] > 1) {
            //Více piv
            stateIgor = 0;
        } 
    } else {
        if (levels[1] >= 2) {
            //2 x energ., nebo cola
            stateIgor = 1;
        } else {
            if (levels[1] > 0) {
                //1 x energ., nebo cola
                stateIgor = 2;
                if (lastLevel == 0) {
                    stateIgor = 3;
                }
            } else {
                stateIgor = 4;
            }
        } 
    }
    
    
   
    setMeter(totalVolume);
    
    if (totalVolume >= MAX_VOLUME) {
        //stateIgor++;
        continueGame = false;
    } 
    
    printDrunkInfo();
        
    updateIgorState();
    
}

function addDrink(name) {
    var i;

    document.getElementById("audioIgorDrink").play();
    
    for (i = 0; i < drinks.length; i++) {
        if (drinks[i].element == name) {
            drinks[i].drunk += 1;
            lastLevel = drinks[i].level;
            levels[drinks[i].level] += 1;
            totalVolume += drinks[i].volume;
        }
    }
    
    setTimeout(function() { countIgorState();}, 500);
}

function initDrunk() {
    var i;
    
    for (i = 0; i < drinks.length; i++) {
        drinks[i].drunk = 0;
    }
    
    for (i = 0; i < levels.length; i++) {
        levels[i] = 0;
    }
    
    totalVolume = 0;
}

function initValues() {
    var i;

    setMeter(0);
    
    stateIgor = 2;
    
    lastLevel = -1;
    
    continueGame = true;
}

function point2comma(txt) {
    return txt.replace('.', ',');
}

function showNextAnimation(e) {
    var i;
    var elem;
    var runNext = false;
    
    if (e !== undefined) {
        
        for (i = 0; (i < initAnimOrder.length) && (!runNext); i++) {
            if ((initAnimOrder[i].class === e.animationName) && (initAnimOrder[i].order === animationState)) {
                animationState++;
                runNext = true;
            }
        }
    } else {
        runNext = true;
    }
    
    if (runNext) {

        for (i = 0; i < initAnimOrder.length; i++) {
            if (initAnimOrder[i].order === animationState) {

                if (initAnimOrder[i].audio !== "") {
                    aud = document.getElementById("audio" + initAnimOrder[i].audio);
                    if (aud !== null) {
                        aud.pause();
                        aud.currentTime = 0;;
                        aud.play();
                    }
                }    

                elem = document.getElementById(initAnimOrder[i].element);
                elem.style.visibility = 'visible';
                elem.classList.add(initAnimOrder[i].class); 
                                
                
            }

        }
    
    }    
        
}

function initialAnimations() {
    
    var i;
    var elem;
    
    animationState = 1;
    
    for (i = 0; i < initAnimOrder.length; i++) {
        elem = document.getElementById(initAnimOrder[i].element);
        elem.addEventListener("animationend", showNextAnimation);
        elem.addEventListener("webkitAnimationEnd", showNextAnimation);
    }

    showNextAnimation();
    
}

function showStatus(status) {
 
    var i;
    var obj;
    
    for (i = 0; i < statuses.length; i++) {
        var obj = document.getElementById('imgStatusCircle' + statuses[i].descr);
    
        if (statuses[i].descr !== status) {
            obj.style.visibility = "hidden";
        } else {
            obj.style.visibility = "visible";
            
            if (statuses[i].audio !== '') {
                aud = document.getElementById("audio" + statuses[i].descr);
                if (aud !== null) {
                    setTimeout(function() { aud.play(); }, 1000);
                }
            }
            
        }
        
            

    }
    
}

function btnMouseEntered() {
    document.getElementById("audioMouseEntered").play();
}


function imgDrinkOver(img) {
    var i;
    var obj;
    
    for (i = 0; i < drinks.length; i++) {
        if (drinks[i].element === img) {
            
            console.log('over: ' + img);
            
            obj = document.getElementById("ImgDrink" + img);
            
            obj.classList.add("animFadeIn");
                
        }
    }
    
}

function imgDrinkOut(img) {
    var i;
    var obj;
    
    for (i = 0; i < drinks.length; i++) {
        if (drinks[i].element === img) {
            
            console.log('out: ' + img);
            
            obj = document.getElementById("ImgDrink" + img);
            
            obj.classList.remove("animFadeIn");
                
        }
    }
    
}


function exitMouseOver(isOver) {
    
    if (isOver) {
        btnMouseEntered();
        document.getElementById("imgExit").setAttribute('src', 'IMG/exit_hover.png');
    } else {
        document.getElementById("imgExit").setAttribute('src', 'IMG/exit.png');
    }
    
}

function setMeter(value) {
    
    var pos = Math.round(10000 - (value / MAX_VOLUME) * 10000) / 100;
    
    document.getElementById("divMeterBar").style.top = pos + '%';
    
}